/*
 * A0B36PRI_091026_05  "PROGRAMOVANI"  08.07.2009 (10.09.2006)
 *   
 * Prednaska 05 - proceduralni programovani
 *
 * Jednoduche metody pro vstup/vystup - Io.java
 *
 */

package a0b36pri_091026_05;

import java.util.*;
import java.io.*;
import java.text.*;             // NumberFormat class here

public class Io {
    static Scanner sc=new Scanner(System.in);
    static BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
    static NumberFormat nf=NumberFormat.getNumberInstance(new Locale("en","US"));
    static DecimalFormat df=(DecimalFormat)nf;
    private static final String zeroes="0000000000000000";

    public static void main(String[] args) {//*//////////////////////////////////////////////////////////
        double d;
        int x;
        boolean b;
        String s="";
        
        // double type test
        // write
        Io.writeLn(" |-------------------------------------------------------|");
        d=-.12345678;
        for(int i=0;i<3;i++){
            Io.write(" | ");
            for(int j=0;j<4;j++){
                Io.write(d,4,2);
                Io.write(" | ");
                d = d + .353;    
            }
            Io.writeLn("");
        }
        Io.writeLn(" |-------------------------------------------------------|");
        Io.writeLn("");

        d=1234.123456;
        Io.writeLn(d,4);
        d=-93456.4567098;
        Io.writeLn(d,6);
        Io.writeLn(d,15);
 
        // double type test
        // read
        Io.writeLn("Input double value");
        d=Io.readLn(d);
        Io.writeLn(d);
        Io.writeLn("d="+d);
        Io.writeLn("Input double value");
        d=Io.read(d);
        Io.writeLn(d);
        
        // int type test
        // write
        x=12345;
        Io.write(x);
        Io.writeLn("");
        Io.writeLn(x);
        Io.writeLn("x="+x);
        
        // int type test
        // read
        Io.writeLn("Input integer value");
        x=Io.readLn(x);
        Io.writeLn("x="+x);
        Io.writeLn("Input integer value");
        x=Io.read(x);
        Io.writeLn("x="+x);

        // boolean type test
        // write
        b=true;
        Io.writeLn(b);
        Io.write(b);
        Io.writeLn("");

        // boolean type test
        // read
        Io.writeLn("Input boolean value");
        b=Io.readLn(b);
        Io.writeLn("b="+b);
        
        // String type test
        // write
        Io.write("No linefeed at the end of line");
        Io.writeLn("");
        Io.writeLn("Line feed at the end of line");

        // String type test
        // read
        Io.writeLn("Type string (all line is read)");
        s=Io.readLn(s);
        Io.writeLn("Line red="+s);
        Io.writeLn("Type string (all line is read)");
        s=Io.read(s);
        Io.writeLn("Line red="+s);

        // wait input to stop
        Io.writeLn("==Input any char to end==");
        x=Io.readLn(x);
    }// main() END //////////////////////////////////////////////////////////////////////////////////////
   
    
    
    public static int read(int x){
        return(readLn(x));
    }

    public static int readLn(int x){
        try {
            x=sc.nextInt();
        }
        catch(Exception e){
            x=0;
        }
    return(x);
    }
    
    public static double read(double d){
        return(readLn(d));
    } 

    public static double readLn(double d){
     //d=Double.NaN;
     d=0.0;
     try {
         String s=br.readLine();
         if (s==null || s.length()==0 ) {return d;}
         d=Double.parseDouble(s);
     }
     catch(Exception e){
         //return Double.NaN;
         return 0.0;
     }
     return d;
    } 

    public static boolean read(boolean b){
        return(readLn(b));
    }

    public static boolean readLn(boolean b){
        try {
            b=sc.nextBoolean();
        } catch(Exception e){
            return(false);
        }
        return(b);
    }
    
    public static String readLn(String s){
        //return(sc.nextLine());
        try {
            return(br.readLine());
        } catch (IOException ex) {
            return("");
        }
    }

    public static String read(String s){
      //return(sc.next());
      return(readLn(s));  
    }
    

   public static void write(int x){
        System.out.print(x);
   }
    
   public static void writeLn(int x){
        System.out.println(x);
   }

   public static void write(double x){
        System.out.print(x);
   }
    
   public static void writeLn(double d){
        System.out.println(d);
   }

   public static void write(double d, int fractNum){
        if(fractNum < 1) fractNum = 1;
        if(fractNum > 16) fractNum = 16;
        String pattern="0.";
        pattern+=zeroes.substring(0,fractNum);
        df.applyPattern(pattern);
        String s=df.format(d);
        System.out.print(s);
    }
    
    public static void writeLn(double d, int fractNum){
        if(fractNum < 1) fractNum = 1;
        if(fractNum > 16) fractNum = 16;
        String pattern="0.";
        pattern+=zeroes.substring(0,fractNum);
        df.applyPattern(pattern);
        String s=df.format(d);
        System.out.println(s);
    }

    public static void write(double d, int fractNum, int exponentNum){
        if(fractNum < 1) fractNum = 1;
        if(fractNum > 16) fractNum = 16;
        if(exponentNum < 1)exponentNum = 1;
        if(exponentNum > 5)exponentNum = 5;
        String pattern="0.";
        pattern+=zeroes.substring(0,fractNum)+'E'+zeroes.substring(0,exponentNum);
        df.applyPattern(pattern);
        String s=df.format(d);
        if(s.charAt(0) != '-') s='+'+s;
        /**/
        // Uppercase exponent 'E'
        if(s.charAt(3+fractNum+1) != '-')
            s=s.substring(0,3+fractNum+1)+'+'+s.substring(3+fractNum+1);
        /**/
        /*
        // Lowercase exponent 'e''
        if(s.charAt(3+fractNum+1) != '-')
            s=s.substring(0,3+fractNum)+"e+"+s.substring(3+fractNum+1);
        else
            s=s.substring(0,3+fractNum)+'e'+s.substring(3+fractNum+1);
        */    
        System.out.print(s);
    }
   
    public static void writeLn(double d, int fractNum, int exponentNum){
        write(d,fractNum,exponentNum);
        System.out.println("");
    }
     
    public static void write(boolean x){
        System.out.print(x);
    }

    public static void writeLn(boolean b){
        System.out.println(b);
    }
    
    public static void write(String s){
        System.out.print(s);
    }
    
    public static void writeLn(String s){
        System.out.println(s);
    }

}// Io class END
