/*
 * A0B36PRI_091026_05  "PROGRAMOVANI"  08.07.2009 
 *   
 * Prednaska 05 - proceduralni programovani
 *
 * Vypocet urciteho integralu lichobeznikovou metodou
 * iteraci a rekursi
 * 
 */

package a0b36pri_091026_05;

public class X05f {//==========================================================

      public static void main(String[] args) {/////////////////////////////////
      int pocetKroku=1000;  
      double pocUhel=0;
      double koncUhel=180;
      double pocX = (2*Math.PI/360)*pocUhel;
      double koncX = (2*Math.PI/360)*koncUhel;
      double krok = (koncX - pocX)/pocetKroku;
      double integral;
      
      Io.writeLn("==X05f==");
      
      integral = integralSinus(krok,pocetKroku);
      Io.write("(1) Integral sin<0,90> = ");
      Io.writeLn(integral,4);

      integral = integralSinus((koncX-pocX)/pocetKroku,pocetKroku);
      Io.write("(2) Integral sin<0,90> = ");
      Io.writeLn(integral,4);

      Io.write("(3) Integral sin<0,90> = ");
      Io.writeLn(integralSinus1(krok,pocetKroku),4);
      
      integral = integralSin(pocUhel,koncUhel,pocetKroku);
      Io.write("(4) Integral sin<0,90> = ");
      Io.writeLn(integral,4);
      
      Io.writeLn("==X05f END==");
    }// main() END /////////////////////////////////////////////////////////////
   
    ////////////////////////////////////////////////////////////////////////////
    // Zadani:
    //      Vypocet urciteho integralu fce sin(x)
    // Vstup:
    //      pocatecni a koncovy uhel, pocet kroku
    // Vystup:
    //      integral fce sinus na int <pocUhel,koncUhel> 
    static double integralSin (double pocUhel, double koncUhel, double pocetKroku){
        pocUhel = (2*Math.PI/360)*pocUhel;
        koncUhel = (2*Math.PI/360)*koncUhel;
        double krok = (koncUhel - pocUhel)/pocetKroku;
        double integral = 0;
        for(double i=pocUhel; i < (koncUhel-krok); i = i + krok){
            integral = integral + ((Math.sin(i)+Math.sin(i+krok))*krok)/2;
      }
      return(integral);
    }// integralSin() END //////////////////////////////////////////////////////

    ////////////////////////////////////////////////////////////////////////////
    // Zadani:
    //      Vypocet urciteho integralu fce sin(x)
    // Vstup:
    //      pocatecni a koncovy uhel [rad], delkaKroku, n (poradi kroku)
    // Vystup:
    //      integral fce sinus na int <pocUhel,koncUhel> 
    //
    // Reseni:
    //      Rekurentni vztah: Integral f(x)<0,n> = sum(Pn-1) + Pn 
    //      Rekurse (rekursivni funkce):
    //
    static double integralSinus (double krok, int n){
        double sumN = ((Math.sin(n*krok) + Math.sin((n-1)*krok))*krok)/2;
        if(n < 0) return(0);
        return(sumN + integralSinus(krok,n-1));
    }// integralSinus() END ////////////////////////////////////////////////////

    ////////////////////////////////////////////////////////////////////////////
    // Zkraceny zapis predchozi fce:
    // Rekurse:
    static double integralSinus1 (double krok, int n){
        if(n < 0) return(0);
        return(((Math.sin(n*krok)+Math.sin((n-1)*krok))*krok)/2
                + integralSinus1(krok,n-1));
    }// integralSinus() END ////////////////////////////////////////////////////

}// X05f class END =============================================================
