/*
 * A0B36PRI_091102_06  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 06 - Pole (array)
 *
 * Pole (array) - pole jako vstupni/vystupni parametr metod
 *                kvadraticka rovnice 
 * 
 */

package a0b36pri_091102_06;
import java.util.*;

public class X06f {
  static {Locale.setDefault (Locale.US);}  

  public static void main(String[] args) {
    double[] koef;
    double[] koren;
    while(true){
      System.out.println("===Vypocet korenu kvadraticke rovnice===");
      koef = ctiKoefKvadrRovnice();
      if(koef[0] <= 0)break; // koef. a==0 => Program END
        koren = korenyKvadrRovnice(koef);
        tiskKorenuKvadrRovnice(koren);
     }// while() END
    System.out.println("===Vypocet korenu kvadraticke rovnice END===");
  }// main() END
  
  static double[] ctiKoefKvadrRovnice(){
    // Input: none
    // Outpur: koef_abc[0]= -1 => Error (a == 0);
    //         koef-abc[1]=a,..[2]=b,..[3]=c
    //==============================================
    Scanner read = new Scanner (System.in);
    double[] d={1.};
    double[] koef_abc = new double[4];
    koef_abc[0]= 1.;      // Input OK indicator
    System.out.println("Zadej koef. a = ");
    koef_abc[1] = read.nextDouble();
    if(koef_abc[1] == 0.){
      koef_abc[0]= -1.; // Input error indicator
      return(koef_abc); // Error return point
    }
    System.out.println("Zadej koef. b = ");
    koef_abc[2] = read.nextDouble();
    System.out.println("Zadej koef. c = ");
    koef_abc[3] = read.nextDouble();     
    return koef_abc;
  }// ctiKoefKvadrRovnice() END
  
  static double[] korenyKvadrRovnice (double[] koef_abc){
    // Input:  koef_abc[1]=a,..[2]=b,..[3]=c; a!=0
    // Output: koreny[0] !=0 => real roots, ==0 => komplex roots
    //         koreny[1]=ReX1,..[2]=ImX1
    //         koreny[3]=ReX2,..[4]=ImX2;
    //===========================================================
    final int Ka=1,Kb=2,Kc=3;
    double diskriminant;
    double sqrDiskriminant;
    double[] koreny = new double[5];
    final int ReKompl=0,ReX1=1,ImX1=2,ReX2=3,ImX2=4;
    diskriminant = koef_abc[Kb]*koef_abc[Kb]-4*koef_abc[Ka]*koef_abc[Kc];
    if(diskriminant >= 0.){
      sqrDiskriminant = Math.sqrt(diskriminant);
      koreny[ReX1] = (-koef_abc[Kb]+sqrDiskriminant)/(2*koef_abc[Ka]);
      koreny[ImX1] = 0.;
      koreny[ReX2] = (-koef_abc[Kb]-sqrDiskriminant)/(2*koef_abc[Ka]);
      koreny[ImX2] = 0.;
      koreny[ReKompl] = 1.; // != 0. => Real roots indicator
    }
    else{// D < 0.
      sqrDiskriminant = Math.sqrt(-diskriminant);
      koreny[ReX1] = -koef_abc[Kb]/(2*koef_abc[Ka]);
      koreny[ImX1] = sqrDiskriminant/(2*koef_abc[Ka]);
      koreny[ReX2] = -koef_abc[Kb]/(2*koef_abc[Ka]);
      koreny[ImX2] = -sqrDiskriminant/(2*koef_abc[Ka]);;
      koreny[ReKompl] = 0.; // == 0. => Komlex roots indicator
    }// if()else END
    return(koreny);
  }// korenyKvadrRovnice() END
  
  static void tiskKorenuKvadrRovnice (double[] koreny){
    final int ReKompl=0,ReX1=1,ImX1=2,ReX2=3,ImX2=4;
    if(koreny[ReKompl] != 0){
      // Real roots
      System.out.println("x1="+koreny[ReX1]+"+"+koreny[ImX1]);
      System.out.println("x2="+koreny[ReX2]+"+"+koreny[ImX2]);
    }
    else{
      // komplex roots
      if(koreny[ImX1] >= 0){
        System.out.println("x1="+koreny[ReX1]+"+j"+koreny[ImX1]);
        System.out.println("x2="+koreny[ReX1]+"-j"+koreny[ImX1]);
      }
      else{
        System.out.println("x1="+koreny[ReX1]+"-j"+(-koreny[ImX1]));
        System.out.println("x2="+koreny[ReX1]+"+j"+(-koreny[ImX1]));
      }
    }
  }// tiskKorenuKvadrRovnice() END
  
}// class X06f END
