/*
 * A0B36PRI_091116_07a  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 07 - Objektove programovani
 *
 * Pocitani vzniklych/zaniklych objektu, toString(). finalizer
 *
 */

package a0b36pri_091116_07a;

public class X08d {//===========================================================
    
    public static void main(String[] args) {
        Zakaznik z1 = new Zakaznik ("Novak",1000);
        System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());
        System.out.println(z1.toString());
        
        Zakaznik z2 = new Zakaznik ("Dvorak",5000);
        System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());

        Zakaznik z3 = new Zakaznik ("Hosek",8000);
        System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());
        
        z2 = null;
        System.runFinalization();
        System.gc();
        while(true){
            System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());
            if(Zakaznik.getPocetZakazniku() < 3){
                System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());
                break;    
            }
        }
        
        z1 = null;
        System.runFinalization();
        System.gc();                    // run Garbage Collector
        while(true){
            System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());
            if(Zakaznik.getPocetZakazniku() < 2){
                System.out.println("Pocet zakazniku = "+ Zakaznik.getPocetZakazniku());
                break;    
            }
        }// while() END
    }// main() END
    
}// X08d class END =============================================================

class Zakaznik {//==============================================================
    static int pocetZakazniku = 0;
    String jmeno = "";
    int stavUctu = 0;
    
    public Zakaznik (String jmeno, int vlozit){
        pocetZakazniku ++;
        this.jmeno = jmeno;
        this.stavUctu = vlozit;
    }// Constructor END

    public Zakaznik (String jmeno){
        pocetZakazniku ++;
        this.jmeno = jmeno;
    }// Constructor END (constructor overloading - pretizeni)

    
    protected void finalize() throws Throwable{
        pocetZakazniku --;
        System.out.println("Konec zakaznika");  // Ladici tisk
        super.finalize();
    }// finalize()END (finalize() everriding - prekryti)
    
    static int getPocetZakazniku(){
        return(pocetZakazniku);
    }// pocetZakazniku() END
    
    void setVlozit (int vlozit){
        this.stavUctu += vlozit;
    }// setVlozit() END
    
    int getVybrat (int kolikVybrat){
        int vybrat;
        if(this.stavUctu >= kolikVybrat){
            vybrat = kolikVybrat;
            this.stavUctu = this.stavUctu - kolikVybrat;
        }
        else{
            vybrat = this.stavUctu;
            this.stavUctu = 0;
        }
        return(vybrat);
    }// getVypbrat() END
    
    int getStavUctu (){
        return(this.stavUctu);
    }// getStavUctu() END
    
    // Find class name
    public String toString(){// method Overriding - prekryti
        return(new String(getClass().getName()));
    }// toString() END
    
}// Zakaznik class END ========================================================
